% The contour C is encoded as follows: C(1,i)  ->  g1(  t(i))
%                                      C(2,i)  ->  g1'( t(i))
%                                      C(3,i)  ->  g1''(t(i))
%                                      C(4,i)  ->  g2(  t(i))
%                                      C(5,i)  ->  g2'( t(i))
%                                      C(6,i)  ->  g2''(t(i))

function [C,curvelen] = OMNICONT_construct_contour(ntot,flag_geom)

r        = 0.3;
k        = 3;

tt       = linspace(0,2*pi*(1 - 1/ntot),ntot);
C        = zeros(6,ntot );
C(1,:)   =   1.5*cos(tt) + (r/2)*            cos((k+1)*tt) + (r/2)*            cos((k-1)*tt);
C(2,:)   = - 1.5*sin(tt) - (r/2)*(k+1)*      sin((k+1)*tt) - (r/2)*(k-1)*      sin((k-1)*tt);
C(3,:)   = - 1.5*cos(tt) - (r/2)*(k+1)*(k+1)*cos((k+1)*tt) - (r/2)*(k-1)*(k-1)*cos((k-1)*tt);
C(4,:)   =       sin(tt) + (r/2)*            sin((k+1)*tt) - (r/2)*            sin((k-1)*tt);
C(5,:)   =       cos(tt) + (r/2)*(k+1)*      cos((k+1)*tt) - (r/2)*(k-1)*      cos((k-1)*tt);
C(6,:)   = -     sin(tt) - (r/2)*(k+1)*(k+1)*sin((k+1)*tt) + (r/2)*(k-1)*(k-1)*sin((k-1)*tt);
curvelen = 2*pi;

return

