function EFG = OMNI_invert_HSS_dsym(NODES)

nboxes  = size(NODES,2);
EFG     = cell(3,nboxes);
ATD_VEC = cell(1,nboxes);

% Loop over all nodes, from finest to coarser.
for ibox = nboxes:(-1):2
    
  % Assemble the diagonal matrix.
  if (NODES{5,ibox}==0) % ibox is a leaf.
    AD    = NODES{40,ibox};
  elseif (NODES{5,ibox}==1) % ibox has precisely one child
    ison  = NODES{4,ibox}(1);
    AD    = ATD_VEC{ison};
  elseif (NODES{5,ibox}==2) % ibox has precisely two children
    ison1 = NODES{4,ibox}(1);
    ison2 = NODES{4,ibox}(2);
    AD    = [ATD_VEC{ison1},NODES{46,ison1};...
             NODES{46,ison2},ATD_VEC{ison2}];
  end
  
  % Construct the V matrices.
  n                  = NODES{8,ibox};
  k                  = NODES{9,ibox};
  Jout               = NODES{31,ibox};
  V                  = zeros(n,k);
  V(Jout(1:k),    :) = eye(k);
  V(Jout((k+1):n),:) = NODES{30,ibox}';
  
  % Construct the various projection maps.
  ADinv            = inv(AD);
  ATD              = inv(V'*ADinv*V);
  ATD_VEC{ibox}    = ATD;
  EFG{2,ibox}      = ATD*(V')*ADinv;
  EFG{3,ibox}      = ADinv - (ADinv*V)*EFG{2,ibox};

end

% Assemble the "top matrix" and invert it:
AT = [ATD_VEC{2},NODES{46,2};...
      NODES{46,3},ATD_VEC{3}];

EFG{3,1} = inv(AT);

return